/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2009 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
/*!
 *  \file   toppers/macro_processor.hpp
 *  \brief  ޥΤ
 *
 *  Υե륯饹
 *  \code
 *  class macro_processor;
 *  \endcode
 */
#ifndef TOPPERS_MACRO_PROCESSOR_HPP_
#define TOPPERS_MACRO_PROCESSOR_HPP_

#include <string>
#include <vector>
#include <stack>
#include <map>
#include "toppers/workaround.hpp"
#include "toppers/output_file.hpp"
#include "toppers/text.hpp"

namespace toppers
{

  class macro_processor
  {
  public:
    struct context;

    /*!
     *  \struct element macro_processor.hpp "toppers/macro_processor.hpp"
     *  \brief  ޥǻѤѿ
     *
     *  ΤˤϡѿͤϾ˽դꥹȤȤưޤelement ϽդꥹȤ 1 Ǥɽޤ
     */
    struct element
    {
      boost::optional< std::tr1::int64_t > i;
      std::string v;
      std::string s;
    };
    /*!
     *  \brief  ޥǻѤѿɽ뷿
     */
    typedef std::vector< element > var_t;

    /*!
     *  \struct func_t macro_processor.hpp "toppers/macro_processor.hpp"
     *  \brief  ޥǰؿɽ뷿
     *  \note   ñʹ¤ΤǤäᡢߴΤᡢΤݻƤ롣
     *  \attention  node ν˺
     */
    struct func_t
    {
      std::string name;   //!< ؿ̾
      var_t ( * f )( text_line const& line, std::vector< var_t > const&, context* );  //!< 
      void const* node;
    };

    // modified by takuya 110823
    typedef void ( * hook_t )( text_line const&, std::string const&, var_t const&, var_t const&, context* );

    struct context
    {
      std::stack< var_t > stack;
      std::map< std::string, var_t > var_map;
      std::map< std::string, func_t > func_map;
      bool in_function;
      output_file target_file;
      hook_t hook_on_assign;
      text_line line;
      // modified by takuya 110823
      // hoaϾάǽʤΤǡϤʤϤ
      // ǡ2ĤΥ󥹥ȥ饯ȡ
      // ʤΥ󥹥ȥ饯Ƥˤɤ
      // ŬѤ뤫ȽǤǤѥ륨顼Ȥʤ뤿ᡤ
      // context()
      // context() : in_function( false ) {}
      explicit context( hook_t hoa = 0 ) : hook_on_assign( hoa ), in_function( false ) {}
    };

    struct die_terminate {};

    // modified by takuya 110823
    // άǽɲäʤΤǡϤʤϤ
    // ǡάǽʰɲä줿󥹥ȥ饯ȡ
    // ʤΥ󥹥ȥ饯ƤɲäΤɤ
    // ŬѤ뤫ȽǤǤѥ륨顼Ȥʤ뤿ᡤ
    // ɲäΥ󥹥ȥ饯
    // Τ褦ˤȤmacro_processor.cppǤ
    // ̷⤬ᡤάǽϻȤʤ褦ˤ
    macro_processor();
    //explicit macro_processor( hook_t hook_on_assign = 0 );
    explicit macro_processor( hook_t hook_on_assign );
    macro_processor( macro_processor const& other );
    explicit macro_processor( text const& in );
    //explicit macro_processor( text const& in, hook_t hook_on_assign = 0 );
    explicit macro_processor( text const& in, hook_t hook_on_assign );

    ~macro_processor();
    macro_processor& operator=( macro_processor const& other );
    void swap( macro_processor& other );
    void evaluate( text const& in );
    void set_var( std::string const& name, var_t const& value );
    void set_var( std::string const& name, long name2, var_t const& value );
    var_t const& get_var( std::string const& name ) const;
    var_t const& get_var( std::string const& name, long name2 ) const;
    void add_builtin_function( func_t const& f );

    static void remove_comment( text const& in, text& out );
    static void expand_include( text const& in, text& out );
    static void preprocess( text const& in, text& out );
    static std::tr1::int64_t to_integer( var_t const& var, context const* p_ctx );
    static std::string to_string( var_t const& var, context const* p_ctx );
    static bool check_arity( text_line const& line, std::size_t arity, std::size_t valid, char const* function_name );
    static var_t call_user_function( text_line const& line, std::vector< var_t > const& arg_list, context* p_ctx );
  private:
    context* p_ctx_;
    static func_t const builtin_function_table[];
  };

  inline bool operator == ( macro_processor::element const& lhs, macro_processor::element const& rhs )
  {
    return lhs.i == rhs.i;
  }

  inline bool operator < ( macro_processor::element const& lhs, macro_processor::element const& rhs )
  {
    return lhs.i < rhs.i;
  }

  struct element_eq
  {
    explicit element_eq( std::tr1::int64_t value ) : value_( value ) {}
    bool operator()( toppers::macro_processor::element const& e ) const
    {
      return e.i && ( e.i.get() == value_ );
    }
    std::tr1::int64_t value_;
  };

}

#endif  // ! TOPPERS_MACRO_PROCESSOR_HPP_
